package com.officetetsu.selfishrestaurant;

import java.util.Arrays;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.TextView.OnEditorActionListener;

public class SelfishRestaurant extends Activity
implements
DialogInterface.OnClickListener,
OnEditorActionListener,
OnClickListener {

	EditText editText;
	Button button;
	TextView textView;
	AlertDialog  buttonDialog, listDialog;
	CharSequence[] items;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		editText = (EditText)findViewById(R.id.editText1);
		editText.setOnEditorActionListener(this);
		button = (Button)findViewById(R.id.button1);
		button.setOnClickListener(this);
		textView = (TextView)findViewById(R.id.textView2);
		items = getResources().getStringArray(R.array.list_items);
		Arrays.sort(items);
	}

	@Override
	public void onClick(DialogInterface arg0, int arg1) {
		// TODO Auto-generated method stub
		
		if(arg0 == listDialog){
			editText.setText(items[arg1]);
		}else
		if(arg0 == buttonDialog){
			CharSequence order = editText.getText().toString();
			switch(arg1){
			case DialogInterface.BUTTON_POSITIVE:
				textView.append("\n" + order);
				break;
			case DialogInterface.BUTTON_NEGATIVE:
				editText.setText("");
				break;
			case DialogInterface.BUTTON_NEUTRAL:
				//Never execute
				break;
			}
		}
	}
	
	@Override
	public boolean onEditorAction(TextView v, int actionId, KeyEvent event) {
		// TODO Auto-generated method stub
		if(v == editText){
			if(event.getAction() == KeyEvent.ACTION_DOWN){
				CharSequence order = editText.getText().toString();
				if(Arrays.binarySearch(items,order) < 0){
					buttonDialog = new AlertDialog.Builder(this)
					.setTitle(R.string.title1)
					.setMessage(R.string.message)
					.setCancelable(false)
					.setPositiveButton(R.string.btn_top_yes, this)
					.setNegativeButton(R.string.btn_top_no, this)
					.setNeutralButton(R.string.btn_top_cancel, null)
					.show();
				}else{
					textView.append("\n" + order);
					editText.setText("");
				}
			}
			return true;
		}
		return false;
	}

	@Override
	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		if(arg0 == button){
			listDialog = new AlertDialog.Builder(this)
			.setTitle(R.string.title2)
			.setCancelable(true)
			.setItems(items, this)
			.show();
		}
	}
}